#include <stdio.h>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <math.h>
#define sqr(x) ((x)*(x))
#include <float.h>
typedef long double real;
using namespace std;
const int MaxN = 5000;
const real DegRad = M_PI / 180;
const int r = 6373;
struct{
  real x, y, z;
}p[MaxN];
int i, j, k, l, n, m;
real lat, lon, tmp, mins[MaxN];;
FILE *fi, *fo;

inline void GetMins(int &i){
  if(tmp < mins[i]){
    mins[i] = tmp;
  }
}

int main(){
  for(i = 0; i < MaxN; i++){
    mins[i] = DBL_MAX;
  }
  fi = fopen("input.txt", "r");
  fo = fopen("output.txt", "w");
  fscanf(fi, "%i", &n);
  for(i = 0; i < n; i++){
    fscanf(fi, "%lf%lf", &lon, &lat);
    lon *= DegRad;
    lat *= DegRad;
    p[i].x = cos(lon)*cos(lat);
    p[i].y = sin(lon)*cos(lat);
    p[i].z = sin(lat);    
    for(j = 0; j < i; j++){
      tmp = sqr(p[i].x-p[j].x) + sqr(p[i].y-p[j].y) + sqr(p[i].z-p[j].z);
      GetMins(i); GetMins(j);
    }
  }
  for(i = 0; i < n; i++){
    fprintf(fo, "%0.3lf\n", acos(1-0.5*mins[i])*r);
  }
  fclose(fi);
  fclose(fo);
  return 0;
}